package net.sdls.barista.tech.robot;

import junit.framework.TestCase;

public class GreetingRobotTest extends TestCase {

	/**
	 * 쐬㖼Ouf[^vƂAA擾eXg
	 * "ɂ́B̖O̓f[^łB"
	 * Ƃ^[鎖mF
	 */
	public void testGetMessage() throws Exception {
		GreetingRobot robot = new GreetingRobot(2007, 10, 23);
		robot.setName("f[^");
		String message = robot.getMessage();

		if (!"ɂ́B̖O̓f[^łB".equals(message)) {
			fail("bZ[WsłF" + message);
		}
		
		assertEquals("bZ[Wsł", "ɂ́B̖O̓f[^łB", message);
	}
	
	/**
	 * OXɕύXAA擾eXg
	 * ݒ肵OpbZ[W\邱Ƃ܂B
	 */
	 public void testNameChange() throws Exception {
	 	String[] names = {"f[^", "A", "Ag", "E"};
	 	GreetingRobot robot = new GreetingRobot(2007, 10, 20);
	 	
	 	for (int i = 0; i < names.length; i++) {
			robot.setName(names[i]);
			String message = robot.getMessage();
			String answer = "ɂ́B̖O" + names[i] + "łB";
			if (!answer.equals(message)) {
				fail(answer + " != " + message);
			}
		}
	}

	/**
	 * ̃CX^X쐬ꍇɂꂼ̖OȂ𒲂ׂeXg.
	 */ 
	public void testMultiInstance() throws Exception {
		GreetingRobot robot1 = new GreetingRobot(2008, 1, 21);
		GreetingRobot robot2 = new GreetingRobot(2008, 1, 22);
		robot1.setName("f[^");
		robot2.setName("A");
		String message1 = robot1.getMessage();
		String message2 = robot2.getMessage();
		String answer1 = "ɂ́B̖O̓f[^łB";
		String answer2 = "ɂ́B̖O̓AłB";
		
		
		if (!answer1.equals(message1)) {
			fail(answer1 + " != " + message2);
		}
		if (!answer2.equals(message2)) {
			fail(answer1 + " != " + message2);
		}
	}

	/**
	 * ttH[}bĝ̈ȊO̓G[ƂȂ邩ǂ.
	 * ȂAf[^2001`9999N1/1`12/31T|[gA蓾Ȃ͗OƂ.
	 */
	public void testLotFormat() {

		// ŏl
		try {
			GreetingRobot robot1 = new GreetingRobot(2001, 1, 1);
		} catch (Exception e) {
			fail("ŏlG[");
		}

		// ől
		try {
			GreetingRobot robot1 = new GreetingRobot(9999, 12, 31);
		} catch (Exception e) {
			fail("őlG[");
		}

		// ŏlG[o(N)
		try {
			GreetingRobot robot1 = new GreetingRobot(2000, 1, 1);
			fail("ŏlG[(N)o");
		} catch (Exception e) {
		}
		// ŏlG[o()
		try {
			GreetingRobot robot1 = new GreetingRobot(2001, 0, 1);
			fail("ŏlG[()o");
		} catch (Exception e) {
		}
		// ŏlG[o(N)
		try {
			GreetingRobot robot1 = new GreetingRobot(2001, 1, 0);
			fail("ŏlG[()o");
		} catch (Exception e) {
		}

		// őlG[o(N)
		try {
			GreetingRobot robot1 = new GreetingRobot(10000, 1, 1);
			fail("őlG[(N)o");
		} catch (Exception e) {
		}
		// őlG[o()
		try {
			GreetingRobot robot1 = new GreetingRobot(9999, 13, 1);
			fail("őlG[()o");
		} catch (Exception e) {
		}
		// őlG[o()
		try {
			GreetingRobot robot1 = new GreetingRobot(9999, 12, 32);
			fail("ŏlG[()o");
		} catch (Exception e) {
		}
		
		// {12Ȃ31܂ŁA11Ȃ30܂ŁA邤ǂA̎KvłA
		// ŎĂ݂ĂˁB
	}
	
	/**
	 * w肵bg擾ł邩
	 */
	public void testGetLot() throws Exception {
		GreetingRobot robot1 = new GreetingRobot(2008, 1, 21);
		GreetingRobot robot2 = new GreetingRobot(2008, 1, 22);
		String message1 = robot1.getLot();
		String message2 = robot2.getLot();
		String answer1 = "2008N121";
		String answer2 = "2008N122";

		if (!answer1.equals(message1)) {
			fail(answer1 + " != " + message2);
		}
		if (!answer2.equals(message2)) {
			fail(answer1 + " != " + message2);
		}
	}
}
